package com.sun.management.jmx;

import javax.management.Notification;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import javax.management.NotificationListener;

@Deprecated
public class TraceListener implements NotificationListener
{
    protected PrintStream out;
    protected boolean needTobeClosed;
    protected boolean formated;
    
    public TraceListener() {
        this.needTobeClosed = false;
        this.formated = false;
        this.out = System.out;
    }
    
    public TraceListener(PrintStream out) throws IllegalArgumentException {
        this.needTobeClosed = false;
        this.formated = false;
        if (out == null) {
            throw new IllegalArgumentException("An PrintStream object should be specified.");
        }
        this.out = out;
        return;
    }
    
    public TraceListener(String name) throws IOException {
        this.needTobeClosed = false;
        this.formated = false;
        this.out = new PrintStream(new FileOutputStream(name, true));
        this.needTobeClosed = true;
    }
    
    public void setFormated(boolean formated) {
        this.formated = formated;
    }
    
    @Override
    public void handleNotification(Notification notification, Object o) {
        if ((notification instanceof TraceNotification)) {
            TraceNotification traceNotification = (TraceNotification)notification;
            if (this.formated) {
                this.out.print("\nGlobal sequence number: " + traceNotification.globalSequenceNumber + "     Sequence number: " + traceNotification.sequenceNumber + "\nLevel: " + Trace.getLevel(traceNotification.level) + "     Type: " + Trace.getType(traceNotification.type) + "\nClass  Name: " + new String(traceNotification.className) + "\nMethod Name: " + new String(traceNotification.methodName) + "\n");
                if (traceNotification.exception != null) {
                    traceNotification.exception.printStackTrace(this.out);
                    this.out.println();
                }
                if (traceNotification.info != null) {
                    this.out.println("Information: " + traceNotification.info);
                }
            }
            else {
                this.out.print("(" + traceNotification.className + " " + traceNotification.methodName + ") ");
                if (traceNotification.exception != null) {
                    traceNotification.exception.printStackTrace(this.out);
                    this.out.println();
                }
                if (traceNotification.info != null) {
                    this.out.println(traceNotification.info);
                }
            }
        }
    }
    
    public void setFile(String name) throws IOException {
        PrintStream out = new PrintStream(new FileOutputStream(name, true));
        if (this.needTobeClosed) {
            this.out.close();
        }
        this.out = out;
        this.needTobeClosed = true;
    }
}
